////////////////////////////////////////////////////////////////////////////////
//                                 APICulture
//                        (c)  , 1999-2000
//    http://mazurkin.virtualave.net, mazurkin@mailru.com, mazurkin@chat.ru
// _____________________________________________________________________________
//                               " "
////////////////////////////////////////////////////////////////////////////////

unit AclDialogAbout;

interface

uses Windows, Messages, WinLite;

type
  TDialogAbout = class(TLiteDialogBox)
  private
    FUpdateTmr  : Integer;
  protected
    procedure   CreateDialogParams(var DialogParams: TDialogParams); override;
  protected
    procedure   OnCommand(var Msg: TWMCommand); message WM_COMMAND;
    procedure   OnInitDialog(var Msg: TWMInitDialog); message WM_INITDIALOG;
    procedure   OnDestroy(var Msg: TWMDestroy); message WM_DESTROY;
    procedure   OnTimer(var Msg: TWMTimer); message WM_TIMER;
    procedure   OnSysCommand(var Msg: TWMSysCommand); message WM_SYSCOMMAND;
    procedure   UpdateMemoryStatus;
  end;

implementation

{$I res\resource.inc}

////////////////////////////////////////////////////////////////////////////////
//  
////////////////////////////////////////////////////////////////////////////////
procedure TDialogAbout.CreateDialogParams(var DialogParams: TDialogParams);
begin
  inherited;
  DialogParams.Template := MAKEINTRESOURCE(DIALOGABOUT);
end;

////////////////////////////////////////////////////////////////////////////////
//  
////////////////////////////////////////////////////////////////////////////////
procedure TDialogAbout.OnInitDialog(var Msg: TWMInitDialog);
begin
  //   
  UpdateMemoryStatus;
  //  
  FUpdateTmr := SetTimer(WndHandle, 1, 500, nil);
  // 
  Msg.Result := 1;
end;

////////////////////////////////////////////////////////////////////////////////
//  
////////////////////////////////////////////////////////////////////////////////
procedure TDialogAbout.OnDestroy(var Msg: TWMDestroy);
begin
  //  
  KillTimer(WndHandle, FUpdateTmr);
  // 
  Msg.Result := 0;
end;

////////////////////////////////////////////////////////////////////////////////
//    
////////////////////////////////////////////////////////////////////////////////
procedure TDialogAbout.OnCommand(var Msg: TWMCommand);
begin
  //    "OK" -  
  if Msg.ItemID = IDC_ABOUT_OK then
  begin
    EndDialog(WndHandle, IDOK);
    Msg.Result := 1;
  end;
end;

////////////////////////////////////////////////////////////////////////////////
//   
////////////////////////////////////////////////////////////////////////////////
procedure TDialogAbout.UpdateMemoryStatus;
var
  MemStat : TMemoryStatus;
  S       : string;
begin
  //    
  MemStat.dwLength := SizeOf(MemStat);
  GlobalMemoryStatus(MemStat);
  //   
  Str(MemStat.dwMemoryLoad, S);
    SetDlgItemText(WndHandle, IDC_ABOUT_PERCENT, PChar(' : '#9#9+S+'%'));
  Str(MemStat.dwTotalPhys, S);
    SetDlgItemText(WndHandle, IDC_ABOUT_TOTALPHYS, PChar('  : '#9#9+S+' '));
  Str(MemStat.dwAvailPhys, S);
    SetDlgItemText(WndHandle, IDC_ABOUT_AVAILPHYS, PChar('  : '#9#9+S+' '));
  Str(MemStat.dwTotalPageFile, S);
    SetDlgItemText(WndHandle, IDC_ABOUT_TOTALPAGE, PChar('  : '#9#9+S+' '));
  Str(MemStat.dwAvailPageFile, S);
    SetDlgItemText(WndHandle, IDC_ABOUT_AVAILPAGE, PChar('  : '#9#9+S+' '));
  Str(MemStat.dwTotalVirtual, S);
    SetDlgItemText(WndHandle, IDC_ABOUT_TOTALVIRT, PChar('  : '#9#9+S+' '));
  Str(MemStat.dwAvailVirtual, S);
    SetDlgItemText(WndHandle, IDC_ABOUT_AVAILVIRT, PChar('  : '#9+S+' '));
end;

////////////////////////////////////////////////////////////////////////////////
//  
////////////////////////////////////////////////////////////////////////////////
procedure TDialogAbout.OnTimer(var Msg: TWMTimer);
begin
  //    ?
  if Msg.TimerID = FUpdateTmr then
  begin
    //   
    UpdateMemoryStatus;
    // 
    Msg.Result := 0;
  end;
end;

////////////////////////////////////////////////////////////////////////////////
//  
////////////////////////////////////////////////////////////////////////////////
procedure TDialogAbout.OnSysCommand(var Msg: TWMSysCommand);
begin
  //      ,   
  if Msg.CmdType = SC_CLOSE then
  begin
    EndDialog(WndHandle, IDOK);
    Msg.Result := 0;
    Exit;
  end;
  //     
  with TMessage(Msg) do
    DefWindowProc(WndHandle, Msg, WParam, LParam);
end;

end.
