////////////////////////////////////////////////////////////////////////////////
//                                 APICulture
//                        (c)  , 1999-2000
//    http://mazurkin.virtualave.net, mazurkin@mailru.com, mazurkin@chat.ru
// _____________________________________________________________________________
//                                  
////////////////////////////////////////////////////////////////////////////////

unit AclDialogMain;

interface

uses
  AclControlFire,
  Windows, Messages, WinLite;

type
  TDialogMain = class(TLiteDialog)
  private
    FControlFire: TControlFire;
  protected
    procedure   CreateDialogParams(var DialogParams: TDialogParams); override;
  protected
    procedure   OnCommand(var Msg: TWMCommand); message WM_COMMAND;
    procedure   OnInitDialog(var Msg: TWMInitDialog); message WM_INITDIALOG;
    procedure   OnDestroy(var Msg: TWMDestroy); message WM_DESTROY;
  protected
    procedure   OnCommandUpdate;   
  end;

implementation

{$I res\resource.inc}

////////////////////////////////////////////////////////////////////////////////
// TDialogMain
// _____________________________________________________________________________
//  / 
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
//  
////////////////////////////////////////////////////////////////////////////////
procedure TDialogMain.CreateDialogParams(var DialogParams: TDialogParams);
begin
  inherited;
  DialogParams.Template := MAKEINTRESOURCE(DIALOGMAIN);
end;

////////////////////////////////////////////////////////////////////////////////
//  
////////////////////////////////////////////////////////////////////////////////
procedure TDialogMain.OnInitDialog(var Msg: TWMInitDialog);
var
  Rect   : TRect;
  Border : THandle;
begin
  //   
  Border := GetDlgItem(WndHandle, IDC_MAIN_BORDER);
  //   
  FControlFire := TControlFire.Create(Border);
  //     
  GetClientRect(Border, Rect);
  //         
  SetWindowPos(FControlFire.WndHandle, 0, 8, 16, Rect.Right-16, Rect.Bottom-24, SWP_SHOWWINDOW);
  //     
  FControlFire.PartArrayCreate(1000, 15, 3);
  // 
  Msg.Result := 1;
end;

////////////////////////////////////////////////////////////////////////////////
//  
////////////////////////////////////////////////////////////////////////////////
procedure TDialogMain.OnDestroy(var Msg: TWMDestroy);
begin
  //   
  FControlFire.Free;
  // 
  Msg.Result := 0;
end;

////////////////////////////////////////////////////////////////////////////////
// TDialogMain
// _____________________________________________________________________________
// 
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
//    
////////////////////////////////////////////////////////////////////////////////
procedure TDialogMain.OnCommand(var Msg: TWMCommand);
begin
  //   
  case Msg.ItemID of
    CMD_UPDATE_PARAMS : OnCommandUpdate;
  end;  
end;

////////////////////////////////////////////////////////////////////////////////
// TDialogMain
// _____________________________________________________________________________
//  
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
//   
////////////////////////////////////////////////////////////////////////////////
procedure TDialogMain.OnCommandUpdate;
var
  Speed : Integer;
  Count : Integer;
  Size  : Integer;
  Code  : Integer;
  Item  : THandle;
  S     : string[32];
begin
  //   
  Item := GetDlgItem(WndHandle, IDC_MAIN_NUMBER);
  GetWindowText(Item, @S[1], 32);
  Val(S, Count, Code);
  //  
  if (Code <> 0) or (Count < 1) or (Count > 10000) then
  begin
    MessageBox(WndHandle, '     [1..10000]', ' ', MB_OK+MB_ICONWARNING);
    SetFocus(Item);
    SendMessage(Item, EM_SETSEL, 0, -1);
    Exit;
  end;
  //   
  Item := GetDlgItem(WndHandle, IDC_MAIN_SIZE);
  GetWindowText(Item, @S[1], 32);
  Val(S, Size, Code);
  //  
  if (Code <> 0) or (Size < 2) or (Size > 10) then
  begin
    MessageBox(WndHandle, '     [2..10]', ' ', MB_OK+MB_ICONWARNING);
    SetFocus(Item);
    SendMessage(Item, EM_SETSEL, 0, -1);
    Exit;
  end;
  //   
  Item := GetDlgItem(WndHandle, IDC_MAIN_SPEED);
  GetWindowText(Item, @S[1], 32);
  Val(S, Speed, Code);
  //  
  if (Code <> 0) or (Speed < 1) or (Speed > 100) then
  begin
    MessageBox(WndHandle, '     [1..100]', ' ', MB_OK+MB_ICONWARNING);
    SetFocus(Item);
    SendMessage(Item, EM_SETSEL, 0, -1);
    Exit;
  end;
  //  
  FControlFire.PartArrayCreate(Count, Speed, Size);
end;

end.

