////////////////////////////////////////////////////////////////////////////////
//                                 APICulture
//                        (c)  , 1999-2000
//    http://mazurkin.virtualave.net, mazurkin@mailru.com, mazurkin@chat.ru
// _____________________________________________________________________________
//                              OpenGL
////////////////////////////////////////////////////////////////////////////////

unit AclDialogOpenGL;

interface

uses
  AclControlOpenGL,
  Windows, Messages, MMSystem, WinLite;

type
  TDialogOpenGL = class(TLiteDialogBox)
  private
    FControlGL  : TControlOpenGL;
  protected
    procedure   CreateDialogParams(var DialogParams: TDialogParams); override;
  protected
    procedure   OnCommand(var Msg: TWMCommand); message WM_COMMAND;
    procedure   OnInitDialog(var Msg: TWMInitDialog); message WM_INITDIALOG;
    procedure   OnDestroy(var Msg: TWMDestroy); message WM_DESTROY;
    procedure   OnSysCommand(var Msg: TWMSysCommand); message WM_SYSCOMMAND;
  end;

implementation

{$I res\resource.inc}

////////////////////////////////////////////////////////////////////////////////
// TDialogOpenGL
// _____________________________________________________________________________
//  / 
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
//   
////////////////////////////////////////////////////////////////////////////////
procedure TDialogOpenGL.CreateDialogParams(var DialogParams: TDialogParams);
begin
  inherited;
  DialogParams.Template := MAKEINTRESOURCE(DIALOGOPENGL);
end;

////////////////////////////////////////////////////////////////////////////////
//  
////////////////////////////////////////////////////////////////////////////////
procedure TDialogOpenGL.OnInitDialog(var Msg: TWMInitDialog);
var
  Rect   : TRect;
  Border : THandle;
begin
  //   
  Border := GetDlgItem(WndHandle, IDC_OPENGL_BORDER);
  //   
  FControlGL := TControlOpenGL.Create(Border);
  //     
  GetClientRect(Border, Rect);
  //        
  SetWindowPos(FControlGL.WndHandle, 0, 8, 16, Rect.Right-16, Rect.Bottom-24, SWP_SHOWWINDOW);
  //  
  PlaySound('WAVELOOP', hInstance, SND_LOOP+SND_NODEFAULT+SND_RESOURCE+SND_ASYNC+SND_NOWAIT);
  // 
  Msg.Result := 1;
end;

////////////////////////////////////////////////////////////////////////////////
//  
////////////////////////////////////////////////////////////////////////////////
procedure TDialogOpenGL.OnDestroy(var Msg: TWMDestroy);
begin
  //  
  PlaySound(nil, hInstance, SND_NOWAIT);
  //   
  FControlGL.Free;
  // 
  Msg.Result := 0;
end;

////////////////////////////////////////////////////////////////////////////////
// TDialogOpenGL
// _____________________________________________________________________________
//   
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
//    
////////////////////////////////////////////////////////////////////////////////
procedure TDialogOpenGL.OnCommand(var Msg: TWMCommand);
begin
  //    "OK" -  
  if Msg.ItemID = IDC_OPENGL_OK then
  begin
    EndDialog(WndHandle, IDOK);
    Msg.Result := 1;
  end;
end;

////////////////////////////////////////////////////////////////////////////////
//  
////////////////////////////////////////////////////////////////////////////////
procedure TDialogOpenGL.OnSysCommand(var Msg: TWMSysCommand);
begin
  //      ,   
  if Msg.CmdType = SC_CLOSE then
  begin
    EndDialog(WndHandle, IDOK);
    Msg.Result := 0;
    Exit;
  end;
  //     
  with TMessage(Msg) do
    DefWindowProc(WndHandle, Msg, WParam, LParam);
end;

end.
